Coin: SoReorganizeAction Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoReorganizeAction Class Reference
Action Classes

The SoReorganizeAction class reorganizes your scene graph to optimize traversal/rendering. More...

`#include <Inventor/actions/SoReorganizeAction.h>`

Inheritance diagram for SoReorganizeAction:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoReorganizeAction (SoSimplifier *simplifier=NULL)
virtual | ~SoReorganizeAction (void)
SoSeparator * | getSimplifiedSceneGraph (void) const
void | generateNormals (SbBool onoff)
SbBool | areNormalGenerated (void) const
void | generateTriangleStrips (SbBool onoff)
SbBool | areTriangleStripGenerated (void) const
void | generateTexCoords (SbBool onoff)
SbBool | areTexCoordsGenerated (void) const
void | generateVPNodes (SbBool onoff)
SbBool | areVPNodesGenerated (void)
void | matchIndexArrays (SbBool onoff)
SbBool | areIndexArraysMatched (void) const
SoSimplifier * | getSimplifier (void) const
virtual void | apply (SoNode *root)
virtual void | apply (SoPath *path)
virtual void | apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)
Public Member Functions inherited from SoSimplifyAction
| SoSimplifyAction (void)
virtual | ~SoSimplifyAction (void)
Public Member Functions inherited from SoAction
virtual | ~SoAction (void)
virtual SbBool | isOfType (SoType type) const
void | apply (SoAction *beingApplied)
virtual void | invalidateState (void)
AppliedCode | getWhatAppliedTo (void) const
SoNode * | getNodeAppliedTo (void) const
SoPath * | getPathAppliedTo (void) const
const SoPathList * | getPathListAppliedTo (void) const
const SoPathList * | getOriginalPathListAppliedTo (void) const
SbBool | isLastPathListAppliedTo (void) const
PathCode | getPathCode (int &numindices, const int *&indices)
void | traverse (SoNode *const node)
SbBool | hasTerminated (void) const
const SoPath * | getCurPath (void)
SoState * | getState (void) const
PathCode | getCurPathCode (void) const
virtual SoNode * | getCurPathTail (void)
void | usePathCode (int &numindices, const int *&indices)
void | pushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (const PathCode prevpathcode)
void | pushCurPath (void)
void | popPushCurPath (const int childindex, SoNode *node=NULL)
void | popCurPath (void)
void | switchToPathTraversal (SoPath *path)
void | switchToNodeTraversal (SoNode *node)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
static void | startReport (const char *msg)
static void | finishReport (void)
Static Public Member Functions inherited from SoSimplifyAction
static SoType | getClassTypeId (void)
static void | addMethod (const SoType type, SoActionMethod method)
static void | enableElement (const SoType type, const int stackindex)
static void | initClass (void)
Static Public Member Functions inherited from SoAction
static void | initClass (void)
static void | initClasses (void)
static SoType | getClassTypeId (void)
static void | nullAction (SoAction *action, SoNode *node)

## Protected Member Functions
virtual const SoEnabledElementsList & | getEnabledElements (void) const
virtual void | beginTraversal (SoNode *node)
Protected Member Functions inherited from SoAction
| SoAction (void)
virtual void | endTraversal (SoNode *node)
void | setTerminated (const SbBool flag)
virtual SbBool | shouldCompactPathList (void) const

## Static Protected Member Functions
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoSimplifyAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)
Static Protected Member Functions inherited from SoAction
static SoEnabledElementsList * | getClassEnabledElements (void)
static SoActionMethodList * | getClassActionMethods (void)

## Additional Inherited Members
Public Types inherited from SoAction
enum | AppliedCode { NODE = 0 , PATH = 1 , PATH_LIST = 2 }
enum | PathCode { NO_PATH = 0 , IN_PATH = 1 , BELOW_PATH = 2 , OFF_PATH = 3 }
Protected Attributes inherited from SoAction
SoState * | state
SoActionMethodList * | traversalMethods

## Detailed Description

The SoReorganizeAction class reorganizes your scene graph to optimize traversal/rendering.

Note. This is work-in-progress. pederb, 2005-04-05.

The code below is an example of a program that applies an SoReorganizeAction on a scene graph, converting all shapes into shapes that can be rendered using vertex array or VBO rendering.

#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoCoordinate4.h>
#include <Inventor/nodes/SoNormal.h>
#include <Inventor/nodes/SoTextureCoordinate2.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/errors/SoDebugError.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoOutput.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/actions/SoReorganizeAction.h>
#include <cassert>
#include <cstdio>
static void strip_node(SoType type, SoNode * root)
{
SoSearchAction sa;
sa.setType(type);
sa.setSearchingAll(TRUE);
sa.setInterest(SoSearchAction::ALL);
sa.apply(root);
SoPathList & pl = sa.getPaths();
for (int i = 0; i < pl.getLength(); i++) {
SoFullPath * p = (SoFullPath*) pl[i];
if (p->getTail()->isOfType(type)) {
SoGroup * g = (SoGroup*) p->getNodeFromTail(1);
g->removeChild(p->getIndexFromTail(0));
}
}
sa.reset();
}
int
main(int argc, char ** argv )
{
if (argc < 3) {
fprintf(stderr,"Usage: reorganize <infile> <outfile> [nostrip]\n");
return -1;
}
SbBool strip = TRUE;
if (argc > 3) {
if (strcmp(argv[3], "nostrip") == 0) strip = FALSE;
else {
fprintf(stderr,"Usage: reorganize <infile> <outfile> [nostrip]\n");
return -1;
}
}
SoDB::init();
SoInteraction::init();
SoInput input;
SbBool ok = input.openFile(argv[1]);
if (!ok) {
fprintf(stderr,"Unable to open file.\n");
return -1;
}
SoSeparator * root = SoDB::readAll(&input);
SbBool vrml1 = input.isFileVRML1();
SbBool vrml2 = input.isFileVRML2();
if (vrml2) {
fprintf(stderr,"VRML2 not supported yet\n");
return -1;
}
if (!root) {
fprintf(stderr,"Unable to read file.\n");
return -1;
}
root->ref();
fprintf(stderr,"Applying SoReorganizeAction...");
SoReorganizeAction reorg;
reorg.apply(root);
fprintf(stderr,"done\n");
SoOutput out;
if (out.openFile(argv[2])) {
if (strip) { // strip coord3, texcoord and normal nodes
fprintf(stderr,"stripping old nodes from scene graph\n");
strip_node(SoCoordinate3::getClassTypeId(), root);
strip_node(SoCoordinate4::getClassTypeId(), root);
strip_node(SoNormal::getClassTypeId(), root);
strip_node(SoTextureCoordinate2::getClassTypeId(), root);
}
fprintf(stderr,"writing target\n");
SoWriteAction wa(&out);
wa.apply(root);
}
root->unref();
return 0;
} // main()
SbPList::getLength
int getLength(void) const
Definition lists/SbPList.h:103
SoAction::apply
virtual void apply(SoNode *root)
Definition SoAction.cpp:463
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::isOfType
SbBool isOfType(SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
Definition SoBase.cpp:631
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoCoordinate3::getClassTypeId
static SoType getClassTypeId(void)
Definition SoCoordinate3.cpp:86
SoCoordinate4::getClassTypeId
static SoType getClassTypeId(void)
Definition SoCoordinate4.cpp:93
SoDB::readAll
static SoSeparator * readAll(SoInput *input)
Definition SoDB.cpp:682
SoDB::init
static void init(void)
Definition SoDB.cpp:200
SoFullPath
The SoFullPath class allows examination of hidden children in paths.
Definition SoFullPath.h:38
SoFullPath::getTail
SoNode * getTail(void) const
Definition SoFullPath.cpp:84
SoFullPath::getIndexFromTail
int getIndexFromTail(const int index) const
Definition SoFullPath.cpp:106
SoFullPath::getNodeFromTail
SoNode * getNodeFromTail(const int index) const
Definition SoFullPath.cpp:95
SoGroup
The SoGroup class is a node which managed other node instances.
Definition SoGroup.h:40
SoGroup::removeChild
virtual void removeChild(int childindex)
Definition SoGroup.cpp:492
SoInput::isFileVRML1
SbBool isFileVRML1(void)
Definition SoInput.cpp:2409
SoInput::openFile
virtual SbBool openFile(const char *fileName, SbBool okIfNotFound=FALSE)
Definition SoInput.cpp:495
SoInput::isFileVRML2
SbBool isFileVRML2(void)
Definition SoInput.cpp:2423
SoInteraction::init
static void init(void)
Definition SoInteraction.cpp:127
SoNode
The SoNode class is the base class for nodes used in scene graphs.
Definition SoNode.h:56
SoNormal::getClassTypeId
static SoType getClassTypeId(void)
Definition SoNormal.cpp:89
SoOutput::openFile
virtual SbBool openFile(const char *const fileName)
Definition SoOutput.cpp:413
SoPathList
The SoPathList class is a container for pointers to SoPath objects.
Definition SoPathList.h:40
SoReorganizeAction::SoReorganizeAction
SoReorganizeAction(SoSimplifier *simplifier=NULL)
Definition SoReorganizeAction.cpp:400
SoReorganizeAction::apply
virtual void apply(SoNode *root)
Definition SoReorganizeAction.cpp:489
SoSearchAction
The SoSearchAction class provides methods for searching through scene graphs.
Definition SoSearchAction.h:44
SoSearchAction::setType
void setType(const SoType type, const SbBool chkderived=TRUE)
Definition SoSearchAction.cpp:216
SoSearchAction::ALL
@ ALL
Definition SoSearchAction.h:56
SoSearchAction::reset
void reset(void)
Definition SoSearchAction.cpp:382
SoSearchAction::setSearchingAll
void setSearchingAll(const SbBool searchall)
Definition SoSearchAction.cpp:319
SoSearchAction::getPaths
SoPathList & getPaths(void)
Definition SoSearchAction.cpp:372
SoSearchAction::setInterest
void setInterest(const Interest interest)
Definition SoSearchAction.cpp:290
SoTextureCoordinate2::getClassTypeId
static SoType getClassTypeId(void)
Definition SoTextureCoordinate2.cpp:152
SoType
The SoType class is the basis for the runtime type system in Coin.
Definition SoType.h:59

Since
  Coin 2.5

## Constructor & Destructor Documentation

## ◆ SoReorganizeAction()

SoReorganizeAction::SoReorganizeAction | ( | SoSimplifier * | simplifier = NULL | ) |

A constructor.

## ◆ ~SoReorganizeAction()

SoReorganizeAction::~SoReorganizeAction | ( | void |  | ) |
| virtual

The destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoReorganizeAction::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and "downward" casting.

Reimplemented from SoSimplifyAction.

## ◆ getClassTypeId()

SoType SoReorganizeAction::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ addMethod()

void SoReorganizeAction::addMethod | ( | const SoType | type,
|  | SoActionMethod | method )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ enableElement()

void SoReorganizeAction::enableElement | ( | const SoType | type,
|  | const int | stackindex )
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ getEnabledElements()

const SoEnabledElementsList & SoReorganizeAction::getEnabledElements | ( | void |  | ) | const
| protectedvirtual

Returns list of enabled elements.

Reimplemented from SoSimplifyAction.

## ◆ getClassEnabledElements()

SoEnabledElementsList * SoReorganizeAction::getClassEnabledElements | ( | void |  | ) |
| staticprotected

Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ getClassActionMethods()

SoActionMethodList * SoReorganizeAction::getClassActionMethods | ( | void |  | ) |
| staticprotected

Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

## ◆ initClass()

void SoReorganizeAction::initClass | ( | void |  | ) |
| static

Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

## ◆ apply() [1/3]

void SoReorganizeAction::apply | ( | SoNode * | root | ) |
| virtual

Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoSimplifyAction.

## ◆ apply() [2/3]

void SoReorganizeAction::apply | ( | SoPath * | path | ) |
| virtual

Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoSimplifyAction.

## ◆ apply() [3/3]

void SoReorganizeAction::apply | ( | const SoPathList & | pathlist,
|  | SbBool | obeysrules = FALSE )
| virtual

Applies action to the graphs defined by pathlist. If obeysrules is set to `TRUE`, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
  SoAction::apply(SoPath * path)

Reimplemented from SoSimplifyAction.

## ◆ beginTraversal()

void SoReorganizeAction::beginTraversal | ( | SoNode * | node | ) |
| protectedvirtual

This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoSimplifyAction.

The documentation for this class was generated from the following files:

- SoReorganizeAction.h
- SoReorganizeAction.cpp